import json
res_path = '/public/xcsp_instances/new/scripts/classifiers/cop/mznc/results'
with open(res_path, 'r') as infile:
  results = json.load(infile)
infile.close()
infos_path = '/public/xcsp_instances/new/scripts/solvers/cop/infos'
with open(infos_path, 'r') as infile:
  infos = json.load(infile)

def init():
  return {
    'RF': 0, 'SMO': 0, 'sunny': 0,
    '3s': 0, 'satzilla': 0, 'g12cpx': 0
  }
 
def output(x):
  for i in x:
    print i,
  print
 
print 'No.Solvers',
output(sorted(init().keys()))
for n_solvers, item in sorted(results.items(), key = lambda x : int(x[0])):
  score = init()
  m = 0
  #print n_solvers,'solvers'
  for inst in item.keys():
    if infos[inst]['g12cpx']['otime'] == 1:
      opt = 1
    else:
      opt = 0
    
    for rep in range(1, 6):
      m += 1
      info = item[inst][str(rep)]
      info['g12cpx'] = [
	infos[inst]['g12cpx']['score'], 
	opt, 
	infos[inst]['g12cpx']['otime'],
	None,
	infos[inst]['g12cpx']['score_0_1']
      ]
      solvers = score.keys()
      n = len(solvers)
      inst_score = dict((s, 0) for s in solvers)
      for i in range(0, n - 1):
	s_i = solvers[i]
	score_i = info[s_i][0]
        time_i = info[s_i][2]
	for j in range(i + 1, n):
	  s_j = solvers[j]
	  score_j = float(info[s_j][0])
          time_j = float(info[s_j][2])
          if score_i > score_j:
            score[s_i] += 1
            inst_score[s_i] += 1
          elif score_j > score_i:
            score[s_j] += 1
            inst_score[s_j] += 1
          else:
            if score_i > 0:
	      if score_i == 1 and time_i == 0:
		score[s_i] += 0.5
		inst_score[s_i] += 0.5
	      else:
		score[s_i] += time_j / (time_i + time_j)
		inst_score[s_i] += time_j / (time_i + time_j)
	    if score_j > 0:
	      if score_j == 1 and time_j == 0:
		score[s_j] += 0.5
		inst_score[s_j] += 0.5
	      else:
		score[s_j] += time_i / (time_i + time_j)
		inst_score[s_j] += time_i / (time_i + time_j)
      for s in solvers:
	assert 0 <= inst_score[s] < n
        results[n_solvers][inst][str(rep)][s][3] = inst_score[s]
  assert m == 5 * 2670
  print n_solvers,
  output(v for (k, v) in sorted(score.items(), key = lambda x: x[0]))
  
with open(res_path, 'w') as outfile:
  json.dump(results, outfile)
    