import json
res_path = '/public/xcsp_instances/new/scripts/classifiers/cop/mznc/results'
with open(res_path, 'r') as infile:
  results = json.load(infile)
  
score = []
score01 = []
proven = []
time = []
mznc = []
for n_solvers, item in sorted(results.items(), key = lambda x : int(x[0])):
  m = 0
  print n_solvers,'solvers'
  for inst in item.keys():
    for rep in range(1, 6):
      m += 1
      info = item[inst][str(rep)]
      for s in info.keys():
	if s == 'g12cpx':
	  continue
	score.append(info[s][0])
	proven.append(info[s][1])
	time.append(info[s][2])
	mznc.append(info[s][3])
	score01.append(info[s][4])
  assert m == 5 * 2670
assert len(score) == len(proven)  == len(time) == \
       len(mznc)  == len(score01) == 11 * 5 * 5 * 2670

from scipy.stats.stats import pearsonr
print '\n*** proven vs. ***'
print '--- time:',pearsonr(proven, time)[0]
print '--- score:',pearsonr(proven, score)[0]
print '--- mznc:',pearsonr(proven, mznc)[0]

print '\n*** time vs. ***'
print '--- score:',pearsonr(time, score)[0]
print '--- mznc:',pearsonr(time, mznc)[0]

print '\n*** score vs. ***'
print '--- mznc:',pearsonr(score, mznc)[0]
print '--- score 0,1:',pearsonr(score, score01)[0]